import os
import threading
from modules import camera

class CameraHandler:
    def __init__(self):
        self.period = int(os.getenv('TAKE_PIC_PERIOD')) # 撮影間隔
        self.save_path = os.getenv('SAVE_PATH')
        self.cams = self._create_camera_instances()
        self.th_list = []

    def _create_camera_instances(self):
        cameras = camera.get_list_of_cameras()
        cam_list = []

        for i in range(cameras):
            try:
                cam = camera.Camera(self.period, self.save_path)
            except camera.CameraError as e:
                ledhandler.camera_error()

            save_path = cam.get_save_path()
            if not self._is_exists_path(save_path):
                self._create_path(save_path)
            cam_list.append(cam)

        return cam_list

    def _is_exists_path(self, path):
        return os.path.exists(path)

    def _create_path(self, path):
        os.makedirs(path, exist_ok=True)

    def start_take_picture(self):
        for cam in self.cams:
            th = threading.Thread(target=cam.start_take_picture)
            self.th_list.append(th)
            th.start()
