#!/bin/sh

LED_CLASS_PATH=/sys/class/leds

redirect_if_exist() {
	if [ -f "$2" ]; then
		echo "$1" > "$2"
	fi
}

led_control() {
	local LED=$1
	local MODE=$2
	local INTERVAL=250
	if [ ${MODE} == "off" ]; then
		redirect_if_exist none ${LED_CLASS_PATH}/${LED}/trigger
		redirect_if_exist 0 ${LED_CLASS_PATH}/${LED}/brightness
	elif [ ${MODE} == "on" ]; then
		redirect_if_exist none ${LED_CLASS_PATH}/${LED}/trigger
		redirect_if_exist 1 ${LED_CLASS_PATH}/${LED}/brightness
	elif [ ${MODE} == "blink" ]; then
		redirect_if_exist timer ${LED_CLASS_PATH}/${LED}/trigger
		redirect_if_exist ${INTERVAL} ${LED_CLASS_PATH}/${LED}/delay_off
		redirect_if_exist ${INTERVAL} ${LED_CLASS_PATH}/${LED}/delay_on
	fi
}

infinite_loop()
{
	while true;
	do
		sleep 1
	done
}

progress_running() {
	led_control "led1"  "blink"
}

progress_ok() {
	led_control "led1"  "on"
	infinite_loop
}

progress_ng() {
	led_control "led1"  "off"
	infinite_loop
}
